//20100125 - Alain Brobecker
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */
#define TRUE 1
#define FALSE 0

int PossibleOrigins[48] = {
   1,  3,  7, 15, 31, 63,  // .......a  ......ba  .....cba  ....dcba  ...edcba  ..fedcba
   2,  7, 15, 31, 63,127,  // ......b.  .....cba  ....dcba  ...edcba  ..fedcba  .gfedcba
   4, 14, 31, 63,127,255,  // .....c..  ....dcb.  ...edcba  ..fedcba  .gfedcba  hgfedcba
   8, 28, 62,127,255,255,  // ....d...  ...edc..  ..fedcb.  .gfedcba  hgfedcba  hgfedcba
  16, 56,124,254,255,255,  // ...e....  ..fed...  .gfedc..  hgfedcb.  hgfedcba  hgfedcba 
  32,112,248,252,254,255,  // ..f.....  .gfh....  hgfed...  hgfedc..  hgfedcb.  hgfedcba
  64,224,240,248,252,254,  // .g......  hgf.....  hgfe....  hgfed...  hgfedc..  hgfedcb.
 128,192,224,240,248,252}; // h.......  hg......  hgf.....  hgfe....  hgfed...  hgfedc..

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  int c;
  int origin,nb;
  for(origin=0;origin<8;origin++) {
    nb=0;
    printf("P%c={",'A'+origin);
    for(c=0;c<48;c++) {
      if((PossibleOrigins[c] & (1<<origin))!=0) {
        if(nb!=0) { printf(","); }
        printf("%d",c);
        nb++;
      }
    }
    printf("}; nP%c=%d;\n",'A'+origin,nb);
  }
  exit(0);
}

